# osh
# Copyright (C) 2005 Jack Orenstein <jao@geophile.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

"""Usage: help [OSH_COMMAND]

Print usage information for the named osh command.
"""

import osh.oshobjects

def help():
    return _Help()

class _Help(osh.oshobjects.Generator):

    _command_name = None


    # object interface

    def __init__(self):
        osh.oshobjects.Generator.__init__(self, '', (0, 1))


    # OshCommand interface
    
    def doc(self):
        return __doc__

    def setup(self):
        args = self.args()
        if args.has_next():
            self._command_name = args.next_string()
            if args.has_next():
                self.usage()

    # Generator interface
    
    def execute(self):
        if self._command_name:
            try:
                exec('import %s' % self._command_name)
                exec('print %s.__doc__' % self._command_name)
            except:
                self.usage()
        else:
            import osh.command
            import osh.command.help
            print __doc__
            print 'Builtin commands:'
            for command in osh.command.__all__:
                print '\t', command

