# osh
# Copyright (C) 2005 Jack Orenstein <jao@geophile.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import new

# Assume that type being new'ed is in exceptions
import exceptions

class OshError:

    _command_description = None
    _input = None
    _exception_args = None
    _exception_type_name = None
    _exception_message = None

    def __init__(self, command_description, input, exception):
        self._command_description = command_description
        self._input = input
        self._exception_args = exception.args
        self._exception_type_name = str(exception.__class__)
        self._exception_message = str(exception)

    def __str__(self):
        return ('Encountered %s during execution of %s on input %s: %s' %
                (self._exception_type_name,
                 self._command_description,
                 self._input,
                 self._exception_message))

    def recreate_exception(self):
        klass = eval(self._exception_type_name)
        return new.instance(klass, {'args': str(self)})
